class P
{
  PGraphics pg;
  int pts = 10;               // overrides constructor
  float t = 0;
  float delta;
  float sX, sY;
  float x, y, z, rot;
  float larg;
  float radius = 99;          // overrides constructor
  float h = 300;              // overrides constructor

  //vertices
  PVector vertices[][];
  PVector vN, vAux;

  P (float _x, float _y, float _z, float _rot, float _larg, int _h, float _radius, int _points, float slope)
  {//(x medio , y medio , z medio , ang rotac , largura    ,alt med, raio pontas  , pontos      )
    
    pg=Main;  // overrides any imposition
    vC= new PVector (0,0,0);
    vertices = new PVector[2][pts+1];
    x=_x;
    y=_y;
    z=_z;
    rot=radians(_rot);
    larg=_larg;
    h=_h;
    radius = _radius+2;
    vN= unit(-cos(rot), sin(rot), 1);
    //sX=1;
    sX= slope;
    sY=0;

    calcPts();
  }
  
  P (float x1, float y1, float z1, float x2, float y2, float z2, int _h, float _radius, int _points, float slope)
  {//(x ini  , y ini   , z ini   , x fin  , y fin   , z fin   , alt , raio , #pontos   )
    
    pg=Main;  // overrides any imposition
    vC= new PVector (0,0,0);
    vertices = new PVector[2][pts+1];
    x=(x1+x2)/2;
    y=(y1+y2)/2;
    z=(z1+z2)/2;
    rot=-atan2((x2-x1),(y2-y1));
    larg=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))-40;
    h=_h;
    radius = _radius+10;
    vN= unit(-cos(rot), sin(rot), 1);
    sX=slope;
    sY=0;

    calcPts();
  }


  void setS (float _sX, float _sY)
  {
    sX=_sX;
    sY=_sY;
    calcPts();
  }
  void setS (float _sX)
  {
    sX=_sX;
    calcPts();
  }
  void incS (float _isX)
  {
    sX+=_isX;
    calcPts();
  }
  void incR (float _inc)
  {
    rot+=_inc;
    calcPts();
  }
  void incL (float _inc)
  {
    larg+=_inc;
    calcPts();
  }

  // calcula pontos
  void calcPts ()
  {
    //println("recalc" + millis());
    vAux = unit (-sX*cos(rot), -sX*sin(rot), 1);
    vN.set(vAux);        // no P3D sem alteração de matriz


    for (int i = 0; i < 2; i++) {
      t = 0;
      float cte=larg/2;
      for(int j = 0; j <= pts; j++) {
        if (j==pts/2+1) cte=-larg/2;
        vertices[i][j] = new PVector();

        vertices[i][j].x = cos(radians(t)) * radius;
        vertices[i][j].y = sin(radians(t)) * radius+cte;
        if (i==0)
          vertices[i][j].z = (sX*cos(radians(t))+sY*sin(radians(t))) * radius;
        else
          vertices[i][j].z = h;
        t += 360./pts;
      }
      h *= -1;
    }
  }

  void draw ()
  {
    pg.pushMatrix();
    pg.beginDraw();

    delta=PVector.angleBetween(vN, vC);

    pg.translate(x,y);
    pg.stroke(255);
    //pg.strokeWeight(2);
    //println(vN.x);
    //pg.line (0,0,0,50*vN.x, 50*vN.y, 50*vN.z);
    pg.strokeWeight(1);

    pg.rotateZ(rot);

    pg.noStroke();

    // draw cylinder tube
    if (lid==2){
      
      pg.beginShape(TRIANGLE_STRIP);
      for(int j = 0; j <= pts; j++)
      {
        pg.vertex(vertices[0][j].x, vertices[0][j].y, vertices[0][j].z);
        pg.vertex(vertices[1][j].x, vertices[1][j].y, vertices[1][j].z);
      }
      pg.vertex(vertices[0][0].x, vertices[0][0].y, vertices[0][0].z);
      pg.vertex(vertices[1][0].x, vertices[1][0].y, vertices[1][0].z);
      pg.endShape();
    }
    

    //println (cos(delta));

    //draw cylinder lids
    for (int i = 0; i < lid; i++) {
      if (i==0 && lightsmode==0) pg.fill (cos(delta)*200);//fill(cos(delta)*60, cos(delta)*150, cos(delta)*230);
      if (i==1 && lightsmode==0) pg.fill(180);
      pg.beginShape();
      for(int j = 0; j <= pts; j++) {
        pg.vertex(vertices[i][j].x, vertices[i][j].y, vertices[i][j].z);
      }
      pg.endShape(CLOSE);
    }

/*
    //draw normal
    pg.stroke(0,0,255);
    pg.line (0,0,0,0,0,20);
    pg.stroke(0,255,0);
    pg.line (0,0,0,0,-20,0);
    pg.stroke(255,0,0);
    pg.line (0,0,0,20,0,0);
    pg.stroke(50);
    //println(vN.x);
    pg.line (0,0,0,20*vN.x, 0, 20*vN.z);
    pg.noStroke();
*/
    pg.endDraw();
    pg.popMatrix();
  }


  PVector unit (float x, float y, float z)
  {
    float mod=sqrt(x*x+y*y+z*z);
    PVector un = new PVector (x/mod, y/mod, z/mod);
    return un;
  }
}
// http://processing.org/learning/3d/shapetransform.html

